;******************************************************************************
;*
;* Murphy.vxd - Des crans bleus pas comme les autres...
;*
;* Copyright (c) 1999 Christophe Courtois, Christian Hohmann, Miodrag Vallat
;*
;******************************************************************************

	TITLE Murphy - Murphy inside, delirium processor

; Ce fichier contient le corps du programme.

; La logique du programme est la suivante :
;
; - au dmarrage, la fonction VDD!VDD_Msg_ClrScrn est intercepte ;
;
; - lors des appels  VDD!VDD_Msg_ClrScrn, l'ancienne fonction est d'abord
;   appele, puis une loi est choisie au hasard et affiche  un endroit ne
;   perturbant pas l'affichage du texte lgitime plus tard.
;

; Version du programme
VER_MAJ EQU	0
VER_MIN EQU	2

        .386p

        .XLIST
        INCLUDE vmm.inc
	INCLUDE opttest.inc
; Ncessaire pour accder aux dfinitions VDD
MINIVDD	EQU	1
        INCLUDE minivdd.inc
        INCLUDE vwin32.inc
        .LIST

;******************************************************************************
; Segment de donnes verrouill (toujours en mmoire physique)
;******************************************************************************
VxD_LOCKED_DATA_SEG

; Ancienne adresse de VDD!Msg_ClrScrn
Murphy_OldScrn  dd      ?

; Couleurs de l'cran bleu
Murphy_BColor	dd	?
Murphy_FColor	dd	?

; Titre des crans trafiqus
Murphy_Text	db	" Murphy inside - delirium processor "
Murphy_Len	EQU	offset32 $ - offset32 Murphy_Text

; Numro de la dernire loi affiche
Murphy_Idx	dd	?

; Variables du recueil de lois
EXTRN	Murphy_Lois:DWORD
EXTRN	Murphy_Cnt:DWORD

VxD_LOCKED_DATA_ENDS
;******************************************************************************

;******************************************************************************
; Segment de code verrouill (toujours en mmoire physique)
;******************************************************************************
VxD_LOCKED_CODE_SEG

; Ce VxD doit tre initialis aprs VDD, pour pouvoir le trafiquer.
Murphy_Init_Order EQU VDD_Init_Order + 1000h

; Dclaration des diffrents points d'entre (ici, un seul) et des donnes
; administratives. Le programme n'a pas besoin d'ID car il ne fournit aucun
; service.
Declare_Virtual_Device	Murphy, \		; nom
			VER_MAJ, VER_MIN, \	; version
			Murphy_Control, \	; routine de contrle
		       	, \			; ID unique
			Murphy_Init_Order	; ordre d'initialisation

; Nouvelle routine pour VDD!VDD_Msg_ClrScrn
BeginProc Murphy_ClrScrn, Hook_Proc, Murphy_OldScrn

	; Dans un premier temps, laisser le pilote graphique sauvegarder ce qui
	; est ncessaire et passer en mode texte.
        call    [Murphy_OldScrn]

	pushfd
        pushad
	
	; Titre de loi en vido inverse
	mov	eax, [Murphy_FColor]
	VxDCall	VDD_Msg_BakColor
	mov	eax, [Murphy_BColor]
	VxDCall	VDD_Msg_ForColor
	
	lea     esi, Murphy_Text
	mov     ecx, Murphy_Len 
	mov	edx, ((80 - Murphy_Len) / 2)
	mov	eax, 1
	VxDCall VDD_Msg_TextOut
	
	mov	eax, [Murphy_FColor]
	VxDCall	VDD_Msg_ForColor
	mov	eax, [Murphy_BColor]
	VxDCall	VDD_Msg_BakColor
	
	; Choix d'une loi au hasard
	VMMCall	Get_Last_Updated_System_Time
	xor	edx, edx
	div	[Murphy_Cnt]
	cmp	edx, [Murphy_Idx]
	jnz	@choisi
	inc	edx
	cmp	edx, [Murphy_Cnt]
	jb	@choisi
	xor	edx, edx
@choisi:
	mov	[Murphy_Idx], edx
	imul	ecx, edx, 12
	lea	edx, [Murphy_Lois + ecx]
	
	; Premire ligne
	push	edx
	mov	esi, [edx]
	mov	eax, 3
	mov	ecx, [edx + 4]
	sub	ecx, esi
	mov	edx, 80
	sub	edx, ecx
	shr	edx, 1
	VxDCall	VDD_Msg_TextOut
	pop	edx
	lea	edx, [edx + 4]
	
	; Deuxime ligne
	mov	esi, [edx]
	mov	eax, 4
	mov	ecx, [edx + 4]
	jecxz	@saute			; si la 3me ligne est absente...
	push	edx
	sub	ecx, esi
	mov	edx, 80
	sub	edx, ecx
	shr	edx, 1
	VxDCall	VDD_Msg_TextOut
	pop	edx
	
	; Troisime ligne
	mov	esi, [edx + 4]
	mov	eax, 5
@saute:
	mov	ecx, [edx + 8]
	sub	ecx, esi
	mov	edx, 80
	sub	edx, ecx
	shr	edx, 1
	VxDCall	VDD_Msg_TextOut

        popad
	nop
	popfd

        ret
EndProc Murphy_ClrScrn

; Point de contrle du VxD par Windows
BeginProc Murphy_Control

        Control_Dispatch Device_Init, Murphy_Device_Init

        clc
        ret

EndProc Murphy_Control

VxD_LOCKED_CODE_ENDS
;******************************************************************************

;******************************************************************************
; Donnes d'initialisation en mode protg (ne restent pas en mmoire)
;******************************************************************************
VxD_IDATA_SEG

; Nom du rglage de la couleur du texte des crans bleus
TextColorStr	db	"MessageTextColor", 0

; Nom du rglage de la couleur du fond des crans bleus
BackColorStr	db	"MessageBackColor", 0

VxD_IDATA_ENDS
;******************************************************************************

;******************************************************************************
; Code d'initialisation en mode protg (ne reste pas en mmoire)
;******************************************************************************
VxD_ICODE_SEG

; Initialisation et contournement des routines
BeginProc Murphy_Device_Init

IFNDEF WIN31COMPAT
	; Vrifier que VDD est bien charg (sinon, c'est bien trange !)
        mov     eax, VDD_DEVICE_ID
        VMMCall Get_DDB
        or      ecx,ecx
        jz      di_error
ENDIF
	
	; Contourner la routine voulue
        GetVxDServiceOrdinal eax, VDD_Msg_ClrScrn
        lea     esi, Murphy_ClrScrn
        VMMCall Hook_Device_Service
	jc	di_error
IFDEF WIN31COMPAT
	mov	[Murphy_OldScrn], esi
ENDIF
	
	; Dterminer les couleurs d'affichage
	xor	esi, esi		; section [386Enh] de SYSTEM.INI
	mov	eax, -1			; valeur par dfaut : blanc
	lea	edi, TextColorStr
	VMMCall	Get_Profile_Hex_Int
	mov	[Murphy_FColor], eax

	xor	esi, esi		; section [386Enh] de SYSTEM.INI
	mov	eax, 1			; valeur par dfaut : bleu
	lea	edi, BackColorStr
	VMMCall	Get_Profile_Hex_Int
	mov	[Murphy_BColor], eax

	; Initialisation russie
        clc
        ret

di_error:
	; Initialisation infructueuse (si le code en arrive l, Windows est dans
	; un tat de dcrpitude Murphyque suffisamment avance pour que le
	; programme n'ait plus grand intrt...)
        stc
        ret

EndProc Murphy_Device_Init

VxD_ICODE_ENDS
;******************************************************************************

;******************************************************************************
;  Code d'initialisation en mode rel
;******************************************************************************
VxD_REAL_INIT_SEG

; Initialisation en mode rel
BeginProc Murphy_Real_Init

	; Si le programme est dj charg, arrter les frais
        test    bx, Duplicate_Device_ID
        jnz     short duplicate

	; Sinon il n'a aucune donne  faire transiter vers le mode protg
        xor     bx, bx
        xor     si, si
	xor	edx, edx

        mov     ax, Device_Load_Ok
        ret

duplicate:
        mov     ax, Abort_Device_Load + No_Fail_Message
        ret

EndProc Murphy_Real_Init

VxD_REAL_INIT_ENDS
;******************************************************************************

        END
	
; /* ex:set ts=8: */
